package net.weasel.Vegetation;

import java.util.ArrayList;

import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.entity.Player;

public final class Moss
{
	public static void logOutput( String text ) { Vegetation.logOutput( text ); }
    public static ArrayList<Block> getBlockRange(World world, Integer X, Integer Y, Integer Z, Integer Xsize, Integer Ysize ) { return Blocks.getBlockRange( world,X, Y, Z, Xsize, Ysize ); }
    
	public static void growMoss( Player player )
	{
		if( player == null ) return;
	
		if( Vegetation.enableMoss == false ) return;
		
		if( Vegetation.debugging ) logOutput( "Spreading moss.." );

		Block currentBlock = Moss.getMossyStoneBlock( player );
    	Block spreadBlock = null;

		currentBlock = Moss.getMossyStoneBlock( player );

		if( currentBlock != null )
		{
			spreadBlock = Moss.getAdjacentCobblestone(currentBlock);
					
			if( spreadBlock != null )
			{
				if( Vegetation.debugging ) logOutput( "Spreading moss to block " + spreadBlock.getTypeId() + " at " + spreadBlock.getX() + "," + spreadBlock.getY() + "," + spreadBlock.getZ() + "." );
				
				spreadBlock.setType( Material.MOSSY_COBBLESTONE );
			}
		}
	}

    public static Block getMossyStoneBlock( Player player )
    {
    	double pX = player.getLocation().getX();
    	double pY = player.getLocation().getY();
    	double pZ = player.getLocation().getZ();

    	Block currentBlock = null;
    	Integer X;
    	
    	ArrayList<Block> blockRange = getBlockRange( player.getWorld(), (int)pX, (int)pY, (int)pZ, Vegetation.growthRange, Vegetation.verticalRadius );
    	ArrayList<Block> validBlocks = new ArrayList<Block>();
    	
    	for( X = 0; X < blockRange.size(); X++ )
    	{
    		currentBlock = blockRange.get(X);
    	
    		if( currentBlock != null )
    		{
        		if( currentBlock.getTypeId() == 48 ) validBlocks.add( currentBlock );
    		}
    		
    	}
    	
    	if( validBlocks.size() > 0 )
    	{
    		Integer R = Vegetation.generator.nextInt( validBlocks.size() );
    		return( validBlocks.get(R) );
    	}
    	else
    		return( null );
    }

    public static Block getAdjacentCobblestone( Block whichBlock )
    {
		boolean blockFound = false;
		Block cobble = null;
		Block retVal = null;
		
		try
		{
			if( !blockFound )
			{
				cobble = whichBlock.getRelative(BlockFace.NORTH);

				if( cobble.getTypeId() == 4 )
				{
					retVal = cobble;
					blockFound = true;
				}
			}
			
			if( !blockFound )
			{
				cobble = whichBlock.getRelative(BlockFace.EAST);
				
				if( cobble != null )
				{
					if( cobble.getTypeId() == 4 )
					{
						retVal = cobble;
						blockFound = true;
					}
				}
			}

			if( !blockFound )
			{
				cobble = whichBlock.getRelative(BlockFace.SOUTH);
				
				if( cobble != null )
				{
					if( cobble.getTypeId() == 4 )
					{
						retVal = cobble;
						blockFound = true;
					}
				}
			}

			if( !blockFound )
			{
				cobble = whichBlock.getRelative(BlockFace.WEST);
				
				if( cobble != null )
				{
					if( cobble.getTypeId() == 4 )
					{
						retVal = cobble;
						blockFound = true;
					}
				}
			}

			if( !blockFound )
			{
				cobble = whichBlock.getRelative(BlockFace.UP);
				
				if( cobble != null )
				{
					if( cobble.getTypeId() == 4 )
					{
						retVal = cobble;
						blockFound = true;
					}
				}
			}

			if( !blockFound )
			{
				cobble = whichBlock.getRelative(BlockFace.DOWN);
				
				if( cobble != null )
				{
					if( cobble.getTypeId() == 4 )
					{
						retVal = cobble;
						blockFound = true;
					}
				}
			}
		}
		catch( Exception e )
		{
			retVal = null;
		}

		return retVal;
    }
}
